# Class AbstractBridge<TParams, TEventData, TModule>`Abstract`

#### Type Parameters

- #### TParams extends BridgeParams = BridgeParams

- #### TEventData extends ModuleEventData = ModuleEventData

- #### TModule extends Module<ModuleParams, TEventData> = Module<ModuleParams, TEventData>

#### Hierarchy

- AbstractModule<TParams, TEventData>
  - AbstractBridge
    - HttpBridge

#### Implements

- BridgeModule<TParams, TEventData, TModule>

- Defined in modules/packages/bridge/packages/abstract/dist/types/AbstractBridge.d.ts:6

#####
Index

### Constructors

constructor

### Properties

_baseModuleQueryAccountPaths
_queryAccounts
_started
_targetDownResolvers
account
commitArchivist
downResolver
eventData
moduleConfigQueryValidator
params
readArchivist
supportedQueryValidator
upResolver
writeArchivist
configSchema
defaultLogger?

### Accessors

_queryAccountPaths
address
allowAnonymous
config
logger
queries
queryAccountPaths
queryAccounts

### Methods

bindHashes
bindHashesInternal
bindQuery
bindQueryInternal
bindQueryResult
clearListeners
connect
disconnect
discover
emit
emitSerial
initializeQueryAccounts
listenerCount
loadAccount
moduleAccountQuery
off
offAny
on
onAny
once
query
queryHandler
queryable
resolve
start
started
stop
subscribe
targetConfig
targetDiscover
targetDownResolver
targetQueries
targetQuery
targetQueryable
targetResolve
validateConfig
create
factory

## Constructors

### constructor

- new AbstractBridge<TParams, TEventData, TModule>(params): AbstractBridge<TParams, TEventData, TModule>

- #### Type Parameters

  - #### TParams extends BridgeParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.bridge.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    discoverCache?: true | CacheConfig;
    schema: "network.xyo.bridge.config";
    }, "schema">, "schema"> & {
    schema: string;
    }, "schema">> = BridgeParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.bridge.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    discoverCache?: true | CacheConfig;
    schema: "network.xyo.bridge.config";
    }, "schema">, "schema"> & {
    schema: string;
    }, "schema">>

  - #### TEventData extends ModuleEventData<TEventData> = ModuleEventData

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<TEventData, TModule> = Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, TEventData>

  #### Parameters

  - ##### params: TParams

  #### Returns AbstractBridge<TParams, TEventData, TModule>

  Inherited from AbstractModule.constructor

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:22

## Properties

### `Protected` `Readonly` _baseModuleQueryAccountPaths

_baseModuleQueryAccountPaths: Record<"network.xyo.query.module.discover" | "network.xyo.query.module.account" | "network.xyo.query.module.subscribe", string>

Inherited from AbstractModule._baseModuleQueryAccountPaths

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:16

### `Protected` `Readonly` _queryAccounts

_queryAccounts: Record<"network.xyo.query.module.discover" | "network.xyo.query.module.account" | "network.xyo.query.module.subscribe", undefined | AccountInstance>

Inherited from AbstractModule._queryAccounts

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:17

### `Protected` _started

_started: boolean

Inherited from AbstractModule._started

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:18

### `Protected` _targetDownResolvers

_targetDownResolvers: Record<string, BridgeModuleResolver>

- Defined in modules/packages/bridge/packages/abstract/dist/types/AbstractBridge.d.ts:8

### `Protected` `Readonly` account

account: AccountInstance

Inherited from AbstractModule.account

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:19

### `Protected` commitArchivist

commitArchivist: (() => Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.archivist.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<{
parents?: ArchivistParents;
schema: "network.xyo.archivist.config";
storeParentReads?: boolean;
} & Omit<undefined, "schema">, "schema">, "schema"> & {
schema: string;
}, "schema">, undefined>, ArchivistModuleEventData>>)

#### Type declaration

- - (): Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

  - #### Returns Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

Inherited from AbstractModule.commitArchivist

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:44

### `Readonly` downResolver

downResolver: CompositeModuleResolver

Implementation of BridgeModule.downResolver

Inherited from AbstractModule.downResolver

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:14

### eventData

eventData: TEventData

Implementation of BridgeModule.eventData

Inherited from AbstractModule.eventData

- Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:4

### `Protected` `Readonly` moduleConfigQueryValidator

moduleConfigQueryValidator: Queryable<SchemaFields & PayloadFields & BoundWitnessFields & {
query: string;
resultSet?: string;
schema: "network.xyo.boundwitness";
}>

Inherited from AbstractModule.moduleConfigQueryValidator

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:20

### `Readonly` params

params: TParams

Implementation of BridgeModule.params

Inherited from AbstractModule.params

- Defined in protocol/packages/core/dist/types/lib/Base.d.ts:20

### `Protected` readArchivist

readArchivist: (() => Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.archivist.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<{
parents?: ArchivistParents;
schema: "network.xyo.archivist.config";
storeParentReads?: boolean;
} & Omit<undefined, "schema">, "schema">, "schema"> & {
schema: string;
}, "schema">, undefined>, ArchivistModuleEventData>>)

#### Type declaration

- - (): Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

  - #### Returns Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

Inherited from AbstractModule.readArchivist

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:80

### `Protected` `Readonly` supportedQueryValidator

supportedQueryValidator: Queryable<SchemaFields & PayloadFields & BoundWitnessFields & {
query: string;
resultSet?: string;
schema: "network.xyo.boundwitness";
}>

Inherited from AbstractModule.supportedQueryValidator

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:21

### `Readonly` upResolver

upResolver: CompositeModuleResolver

Implementation of BridgeModule.upResolver

Inherited from AbstractModule.upResolver

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:15

### `Protected` writeArchivist

writeArchivist: (() => Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.archivist.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<{
parents?: ArchivistParents;
schema: "network.xyo.archivist.config";
storeParentReads?: boolean;
} & Omit<undefined, "schema">, "schema">, "schema"> & {
schema: string;
}, "schema">, undefined>, ArchivistModuleEventData>>)

#### Type declaration

- - (): Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

  - #### Returns Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

Inherited from AbstractModule.writeArchivist

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:116

### `Static` configSchema

configSchema: string

Overrides AbstractModule.configSchema

- Defined in modules/packages/bridge/packages/abstract/dist/types/AbstractBridge.d.ts:7

### `Static` `Optional` defaultLogger

defaultLogger?: Logger

Inherited from AbstractModule.defaultLogger

- Defined in protocol/packages/core/dist/types/lib/Base.d.ts:21

## Accessors

### `Protected` _queryAccountPaths

- get _queryAccountPaths(): Record<"network.xyo.query.bridge.connect" | "network.xyo.query.bridge.disconnect", string>

- #### Returns Record<"network.xyo.query.bridge.connect" | "network.xyo.query.bridge.disconnect", string>

  Overrides AbstractModule._queryAccountPaths

  - Defined in modules/packages/bridge/packages/abstract/dist/types/AbstractBridge.d.ts:10

### address

- get address(): string

- #### Returns string

  Implementation of BridgeModule.address

  Inherited from AbstractModule.address

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:23

### allowAnonymous

- get allowAnonymous(): boolean

- #### Returns boolean

  Inherited from AbstractModule.allowAnonymous

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:24

### config

- get config(): TParams["config"]

- #### Returns TParams["config"]

  Implementation of BridgeModule.config

  Inherited from AbstractModule.config

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:25

### `Protected` logger

- get logger(): Logger | Console

- #### Returns Logger | Console

  Inherited from AbstractModule.logger

  - Defined in protocol/packages/core/dist/types/lib/Base.d.ts:23

### queries

- get queries(): string[]

- #### Returns string[]

  Implementation of BridgeModule.queries

  Overrides AbstractModule.queries

  - Defined in modules/packages/bridge/packages/abstract/dist/types/AbstractBridge.d.ts:9

### queryAccountPaths

- get queryAccountPaths(): Readonly<Record<string, undefined | string>>

- #### Returns Readonly<Record<string, undefined | string>>

  Inherited from AbstractModule.queryAccountPaths

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:27

### queryAccounts

- get queryAccounts(): Readonly<Record<string, undefined | AccountInstance>>

- #### Returns Readonly<Record<string, undefined | AccountInstance>>

  Inherited from AbstractModule.queryAccounts

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:28

## Methods

### `Protected` bindHashes

- bindHashes(hashes, schema, account?): PromiseEx<unknown, AccountInstance>

- #### Parameters

  - ##### hashes: string[]

  - ##### schema: string[]

  - ##### `Optional` account: AccountInstance

  #### Returns PromiseEx<unknown, AccountInstance>

  Inherited from AbstractModule.bindHashes

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:39

### `Protected` bindHashesInternal

- bindHashesInternal(hashes, schema, account?): Promise<SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  }>

- #### Parameters

  - ##### hashes: string[]

  - ##### schema: string[]

  - ##### `Optional` account: AccountInstance

  #### Returns Promise<SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  }>

  Inherited from AbstractModule.bindHashesInternal

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:40

### `Protected` bindQuery

- bindQuery<T>(query, payloads?, account?): PromiseEx<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]], AccountInstance>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` account: AccountInstance

  #### Returns PromiseEx<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]], AccountInstance>

  Inherited from AbstractModule.bindQuery

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:41

### `Protected` bindQueryInternal

- bindQueryInternal<T>(query, payloads?, account?): Promise<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]]>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` account: AccountInstance

  #### Returns Promise<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]]>

  Inherited from AbstractModule.bindQueryInternal

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:42

### `Protected` bindQueryResult

- bindQueryResult<T>(query, payloads, additionalWitnesses?): PromiseEx<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>, AccountInstance[]>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` additionalWitnesses: AccountInstance[]

  #### Returns PromiseEx<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>, AccountInstance[]>

  Inherited from AbstractModule.bindQueryResult

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:43

### clearListeners

- clearListeners(eventNames): void

- #### Parameters

  - ##### eventNames: keyof TEventData | (keyof TEventData)[]

  #### Returns void

  Implementation of BridgeModule.clearListeners

  Inherited from AbstractModule.clearListeners

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:7

### `Abstract` connect

- connect(): Promisable<boolean, never>

- #### Returns Promisable<boolean, never>

  Implementation of BridgeModule.connect

  - Defined in modules/packages/bridge/packages/abstract/dist/types/AbstractBridge.d.ts:15

### `Abstract` disconnect

- disconnect(): Promisable<boolean, never>

- #### Returns Promisable<boolean, never>

  Implementation of BridgeModule.disconnect

  - Defined in modules/packages/bridge/packages/abstract/dist/types/AbstractBridge.d.ts:16

### discover

- discover(): Promisable<(SchemaFields & PayloadFields & {
  schema: string;
  })[], never>

- #### Returns Promisable<(SchemaFields & PayloadFields & {
  schema: string;
  })[], never>

  Inherited from AbstractModule.discover

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:32

### emit

- emit<TEventName, TEventArgs>(eventName, eventArgs): Promise<void>

- #### Type Parameters

  - #### TEventName extends string | number | symbol = keyof TEventData

  - #### TEventArgs extends EventArgs = TEventData[TEventName]

  #### Parameters

  - ##### eventName: TEventName

  - ##### eventArgs: TEventArgs

  #### Returns Promise<void>

  Implementation of BridgeModule.emit

  Inherited from AbstractModule.emit

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:8

### emitSerial

- emitSerial<TEventName, TEventArgs>(eventName, eventArgs): Promise<void>

- #### Type Parameters

  - #### TEventName extends string | number | symbol = keyof TEventData

  - #### TEventArgs extends EventArgs = TEventData[TEventName]

  #### Parameters

  - ##### eventName: TEventName

  - ##### eventArgs: TEventArgs

  #### Returns Promise<void>

  Implementation of BridgeModule.emitSerial

  Inherited from AbstractModule.emitSerial

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:9

### `Protected` initializeQueryAccounts

- initializeQueryAccounts(): void

- #### Returns void

  Inherited from AbstractModule.initializeQueryAccounts

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:77

### listenerCount

- listenerCount(eventNames): number

- #### Parameters

  - ##### eventNames: keyof TEventData | (keyof TEventData)[]

  #### Returns number

  Implementation of BridgeModule.listenerCount

  Inherited from AbstractModule.listenerCount

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:10

### `Protected` loadAccount

- loadAccount(account?): AccountInstance

- #### Parameters

  - ##### `Optional` account: AccountInstance

  #### Returns AccountInstance

  Inherited from AbstractModule.loadAccount

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:78

### moduleAccountQuery

- moduleAccountQuery(): Promisable<(SchemaFields & PayloadFields & {
  address: string;
  name?: string;
  schema: "network.xyo.address";
  } | SchemaFields & PayloadFields & {
  address: string;
  previousHash?: string;
  schema: string;
  })[], never>

- #### Returns Promisable<(SchemaFields & PayloadFields & {
  address: string;
  name?: string;
  schema: "network.xyo.address";
  } | SchemaFields & PayloadFields & {
  address: string;
  previousHash?: string;
  schema: string;
  })[], never>

  Inherited from AbstractModule.moduleAccountQuery

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:33

### off

- off<TEventName>(eventNames, listener): void

- #### Type Parameters

  - #### TEventName extends string | number | symbol

  #### Parameters

  - ##### eventNames: TEventName | TEventName[]

  - ##### listener: EventListener<TEventData[TEventName]>

  #### Returns void

  Implementation of BridgeModule.off

  Inherited from AbstractModule.off

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:11

### offAny

- offAny(listener): void

- #### Parameters

  - ##### listener: EventAnyListener<EventArgs>

  #### Returns void

  Implementation of BridgeModule.offAny

  Inherited from AbstractModule.offAny

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:12

### on

- on<TEventName>(eventNames, listener): (() => void)

- #### Type Parameters

  - #### TEventName extends string | number | symbol

  #### Parameters

  - ##### eventNames: TEventName | TEventName[]

  - ##### listener: EventListener<TEventData[TEventName]>

  #### Returns (() => void)

  - - (): void

    - #### Returns void

  Implementation of BridgeModule.on

  Inherited from AbstractModule.on

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:13

### onAny

- onAny(listener): (() => void)

- #### Parameters

  - ##### listener: EventAnyListener<EventArgs>

  #### Returns (() => void)

  - - (): void

    - #### Returns void

  Implementation of BridgeModule.onAny

  Inherited from AbstractModule.onAny

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:14

### once

- once<TEventName>(eventName, listener): (() => void)

- #### Type Parameters

  - #### TEventName extends string | number | symbol

  #### Parameters

  - ##### eventName: TEventName

  - ##### listener: EventListener<TEventData[TEventName]>

  #### Returns (() => void)

  - - (): void

    - #### Returns void

  Implementation of BridgeModule.once

  Inherited from AbstractModule.once

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:15

### query

- query<T, TConfig>(query, payloads?, queryConfig?): Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  - #### TConfig extends SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema"> = SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` queryConfig: TConfig

  #### Returns Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

  Implementation of BridgeModule.query

  Inherited from AbstractModule.query

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:34

### `Protected` queryHandler

- queryHandler<T>(query, payloads?): Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

  Overrides AbstractModule.queryHandler

  - Defined in modules/packages/bridge/packages/abstract/dist/types/AbstractBridge.d.ts:13

### queryable

- queryable<T, TConfig>(query, payloads?, queryConfig?): boolean

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  - #### TConfig extends SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema"> = SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` queryConfig: TConfig

  #### Returns boolean

  Implementation of BridgeModule.queryable

  Inherited from AbstractModule.queryable

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:35

### `Protected` resolve

- resolve<TModule>(filter?): Promise<TModule[]>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule> = Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Parameters

  - ##### `Optional` filter: ModuleFilter

  #### Returns Promise<TModule[]>

  Overrides AbstractModule.resolve

  - Defined in modules/packages/bridge/packages/abstract/dist/types/AbstractBridge.d.ts:14

### start

- start(_timeout?): Promisable<void, never>

- #### Parameters

  - ##### `Optional` _timeout: number

  #### Returns Promisable<void, never>

  Implementation of BridgeModule.start

  Inherited from AbstractModule.start

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:36

### started

- started(notStartedAction?): boolean

- #### Parameters

  - ##### `Optional` notStartedAction: "error" | "throw" | "warn" | "log" | "none"

  #### Returns boolean

  Inherited from AbstractModule.started

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:37

### `Protected` stop

- stop(_timeout?): Promisable<AbstractBridge<TParams, TEventData, TModule>, never>

- #### Parameters

  - ##### `Optional` _timeout: number

  #### Returns Promisable<AbstractBridge<TParams, TEventData, TModule>, never>

  Inherited from AbstractModule.stop

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:114

### subscribe

- subscribe(_queryAccount?): void

- #### Parameters

  - ##### `Optional` _queryAccount: AccountInstance

  #### Returns void

  Inherited from AbstractModule.subscribe

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:38

### `Abstract` targetConfig

- targetConfig(address): SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.module.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<undefined, "schema">

- #### Parameters

  - ##### address: string

  #### Returns SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.module.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<undefined, "schema">

  Implementation of BridgeModule.targetConfig

  - Defined in modules/packages/bridge/packages/abstract/dist/types/AbstractBridge.d.ts:17

### `Abstract` targetDiscover

- targetDiscover(address): Promisable<(SchemaFields & PayloadFields & {
  schema: string;
  })[], never>

- #### Parameters

  - ##### address: string

  #### Returns Promisable<(SchemaFields & PayloadFields & {
  schema: string;
  })[], never>

  Implementation of BridgeModule.targetDiscover

  - Defined in modules/packages/bridge/packages/abstract/dist/types/AbstractBridge.d.ts:18

### targetDownResolver

- targetDownResolver(address?): BridgeModuleResolver

- #### Parameters

  - ##### `Optional` address: string

  #### Returns BridgeModuleResolver

  Implementation of BridgeModule.targetDownResolver

  - Defined in modules/packages/bridge/packages/abstract/dist/types/AbstractBridge.d.ts:11

### `Abstract` targetQueries

- targetQueries(address): string[]

- #### Parameters

  - ##### address: string

  #### Returns string[]

  Implementation of BridgeModule.targetQueries

  - Defined in modules/packages/bridge/packages/abstract/dist/types/AbstractBridge.d.ts:19

### `Abstract` targetQuery

- targetQuery(address, query, payloads?): Promisable<undefined | ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>, never>

- #### Parameters

  - ##### address: string

  - ##### query: SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promisable<undefined | ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>, never>

  Implementation of BridgeModule.targetQuery

  - Defined in modules/packages/bridge/packages/abstract/dist/types/AbstractBridge.d.ts:20

### `Abstract` targetQueryable

- targetQueryable(address, query, payloads?, queryConfig?): boolean

- #### Parameters

  - ##### address: string

  - ##### query: SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` queryConfig: SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">

  #### Returns boolean

  Implementation of BridgeModule.targetQueryable

  - Defined in modules/packages/bridge/packages/abstract/dist/types/AbstractBridge.d.ts:21

### targetResolve

- targetResolve(address, filter?): Promise<TModule[]>

- #### Parameters

  - ##### address: string

  - ##### `Optional` filter: ModuleFilter

  #### Returns Promise<TModule[]>

  Implementation of BridgeModule.targetResolve

  - Defined in modules/packages/bridge/packages/abstract/dist/types/AbstractBridge.d.ts:12

### `Protected` validateConfig

- validateConfig(config?, parents?): boolean

- #### Parameters

  - ##### `Optional` config: unknown

  - ##### `Optional` parents: string[]

  #### Returns boolean

  Inherited from AbstractModule.validateConfig

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:115

### `Static` create

- create<TModule>(this, params?): Promise<TModule>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule>

  #### Parameters

  - ##### this: CreatableModule<TModule>

  - ##### `Optional` params: TModule["params"]

  #### Returns Promise<TModule>

  Inherited from AbstractModule.create

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:30

### `Static` factory

- factory<TModule>(this, params?): CreatableModuleFactory<TModule>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule>

  #### Parameters

  - ##### this: CreatableModule<TModule>

  - ##### `Optional` params: TModule["params"]

  #### Returns CreatableModuleFactory<TModule>

  Inherited from AbstractModule.factory

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:31

Generated using TypeDoc